/*
 *  megamanstructs.h
 *  lady million
 *
 *  Created by increpare on 15/08/2008.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */


/*
 object types
 
 	Platform(int p_y, int p_on, int p_off, int p_loopsize) 
	Smashcrate(int p_y)
	Conveyor(int p_bottom, int p_top, int p_time)
	Helmetdude(int p_y)
	Spike(int p_y, int p_on, int p_off, int p_loopsize)
	Bossbarrier()
 
 enum EntityTypes {e_platform, e_smashcrate, e_conveyor, e_helmetdude, e_spike,e_bossbarrier}
 */
#include <iostream>

enum EntityTypes {e_player,e_platform, e_pplatform, e_smashcrate, e_conveyor, e_bird, e_helmetdude, e_spinner, e_spike,e_bossbarrier, e_rickety, e_done};

class Platform: public Entity
	{
	public:
		int timer;
		int on;
		int off;
		int loopsize;
		bool passthrough;
		bool halfmaterial;
		virtual void move() {
			timer=(timer+1)%loopsize;
			material=((timer>=on)&&(timer<off)) ;
			
			//time spent in material
			
			bool oldhalfvis=halfmaterial;		  //easier than calculating again...
			if (!material) {
				int curoff;
				int offtime=on+loopsize-off;
				
				if (timer>off)
					curoff=timer-off;
				else
					curoff=timer+loopsize-off;
				if (curoff>(2*offtime/3)) halfmaterial=true;
				else halfmaterial=false;
			}
			
			int scy=screencoord(y);
			if (scy> -tilesize && scy<=144) {
				if (material) {
					if (timer==on)
						playfull=true;
				}
				else if ((!oldhalfvis)&&halfmaterial) {
					playhalf=true;
				}
			}
		}
		virtual void draw() {
			if (material)
				masked_blit(leveltiles[tileoffset(level)][8],buffer,0,0,x,screencoord(y),size.x,size.y);
			else if (halfmaterial)
				masked_blit(leveltiles[tileoffset(level)][9],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
		virtual void hit(int d){};
		Platform(int p_y, int p_on, int p_off, int p_loopsize, bool p_passthrough=false) {
			y=p_y;
			on=p_on;
			off=p_off;
			loopsize=p_loopsize;
			timer=0;
			x=tilesize*4;
			size.x=tilesize;
			size.y=tilesize;
			passthrough=p_passthrough;
		}
	};

int weaponsize[levelcount][2]={{6,7},{5,6},{5,16},{9,13},{6,7}};

class Bullet: public Entity
	{
	public:
		int life;
		//use damage to store weapon type
		Bullet(int bx, int by, int bwep) {
			life=50;
			x=bx;
			y=by;
			damage=bwep;
			material=true;
			size.x=weaponsize[damage][0];
			size.y=weaponsize[damage][1];
		}
		void move() {
			y-=4;
			life--;
			if ((y<tilesize-1)||(y>maxy+tilesize-7)||(life==0)) {
				deleteentity(this);
				return;
			}
			
			for (int i=0;i<entitycount;i++) {
				if (entities[i]->hittype==h_yes) {
					if (intersectsegments(y,y+size.y,entities[i]->y,entities[i]->y+entities[i]->size.y)) {
						entities[i]->hit(1);
						deleteentity(this);
						return;
					}
				}
				else if (entities[i]->hittype==h_deflect) {
					if (intersectsegments(y,y+size.y,entities[i]->y,entities[i]->y+entities[i]->size.y)) {
						addentity(new Particle(x,y,8,7,size.x,size.y,shottiles[damage]));
						playsample(s_deflect);
						deleteentity(this);
						return;
					}
				}
			}
		}
		void draw() {
			masked_blit(shottiles[damage],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
	};



class Enemybullet: public Entity
	{
	public:
		int life;
		int dir; //either + or - 1
		//use damage to store weapon type
		Enemybullet(int bx, int by, int bdir) {
			life=20;
			dir=bdir;
			x=bx;
			y=by;
			material=true;
			size.x=6;
			size.y=7;
			canhurt=true;
			damage=2;
			hittype=h_no;
		}
		void move() {
			y=y+4*dir;
			life--;
			
			if ((y<tilesize-1)||(y>maxy+tilesize-7)||(life==0)) {
				deleteentity(this);
				return;
			}
	/*		else for (int i=0;i<entitycount;i++) {
				if (entities[i]->hittype==h_deflect) {
					if (intersectsegments(y,y+size.y,entities[i]->y,entities[i]->y+entities[i]->size.y)) {
						addentity(new Particle(x,y,8,7,size.x,size.y,shottiles[damage]));
						playsample(s_deflect);
						deleteentity(this);
					}
				}
			}*/
		}
		
		void draw() {
			masked_blit(shottiles[0],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
	};



class Ricketyfalling: public Entity
	{
	public:
		int health;
		int damaged;
		//use damage to store weapon type
		Ricketyfalling(int by) {
			x=tilesize*4+2;
			y=by;
			material=true;
			size.x=12;
			size.y=8;
			canhurt=true;
			damage=20;
			hittype=h_no;
			health=3;
			damaged=0;
		}
		void hit(int d)
		{
			damaged=5;
				if (health-d>0)
				{
					health-=d;
				}
			else
				deleteentity(this);
		}
		void move() {
			y+=4;
			if (damaged>0)
				damaged--;
			if (y>maxy+2*tilesize)
				deleteentity(this);
			
			/*		else for (int i=0;i<entitycount;i++) {
			 if (entities[i]->hittype==h_deflect) {
			 if (intersectsegments(y,y+size.y,entities[i]->y,entities[i]->y+entities[i]->size.y)) {
			 addentity(new Particle(x,y,8,7,size.x,size.y,shottiles[damage]));
			 playsample(s_deflect);
			 deleteentity(this);
			 }
			 }
			 }*/
		}
		
		void draw() {
			if (damaged%2==0) 
				masked_blit(leveltiles[11][9],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
	};



Platform *platforms[maxplatforms];
int platformcount=0;





class Player: public Entity
	{
	public:
		bool falling;
		bool shooting;
		bool skipmove;
		int jumpingtimer;
		int health;
		int shootwait;
		int weapon;
		Player() {
			x=tilesize*4;
			y=maxy;
			weapon=0;
			jumpingtimer=0;
			size.x=tilesize;
			size.y=tilesize;
			falling=false;
			skipmove=false;
			shootwait=false;
			material=true;
			damaged=0;
			health=maxhealth;
			
		};
		void die() {
			health=0;
			playerdead=true;
			endtimer=endpause;
			playsample(s_teleport_out);
		}
		
		void damage( int i) {
			if (i>=health)
				die();
			else
				health-=i;
		}
		void anydamage() {
			if (damaged==0)
				for (int i=0;i<enemycount;i++) {
					if (enemies[i]->canhurt) {
						int ey=enemies[i]->y;
						int eh=enemies[i]->size.y;
						if (intersectsegments(y,y+size.y,ey,ey+eh)) {
							damaged=60;
							playsample(s_playerhurt);
							damage(enemies[i]->damage);
							enemies[i]->notifyhurt();
							break;
						}
					}
				}
		}
		
		void calcfalling() {
			bool oldfalling=falling;
			if (y<maxy) {
				falling=true;
				
				for (int i=0;i<platformcount;i++)
					if (platforms[i]->material) {
						int platy=platforms[i]->y;
						
						if ((y<platy) && (platy-y<=tilesize)) {
							
							if ((platy-y<tilesize)&&(!(platforms[i]->passthrough))) {
								y=platy-tilesize;
								skipmove=true;
							}
							falling=false;
							if (!(platforms[i]->passthrough))
								jumpingtimer=0;
							
						}
					}
				
			}
			else {
				falling=false;
				jumpingtimer=0;
			}
			if (oldfalling&&(!falling))
				playsample(s_land);
			
		}
		
		bool canmoveup() {
			if (y<=tilesize)
				return false;
			
			for (int i=0;i<platformcount;i++)
				if ((platforms[i]->material)&&(!(platforms[i]->passthrough))) {
					
					int platy=platforms[i]->y;
					int ysize=platforms[i]->size.y;
					if ((y>platy)&&( y-platy  <= ysize )) {
						if ( y-platy  < ysize ) {
							y=platy+ysize;
							skipmove=true;
							jumpingtimer=0;
						}
						return false;
					}
				}
			
			return true;
		}
		
		void move() {
			if (!key[KEY_SPACE])
				spacereleased=true;
			
			if ((gamestate==mm_level)||(gamestate==mm_boss)) {
				calcfalling();
				
				if ((!falling) && key[KEY_SPACE])
					if (canmoveup()&&spacereleased) {
						jumpingtimer=3*tilesize/2+tilesize/2;
						playsample(s_jump);
						spacereleased=false;
					}
				
				if (!skipmove) {
					if (jumpingtimer>0) {
						if (canmoveup()) {
							jumpingtimer--;
							y-=2;
							//				if (y==tilesize)
							//					gamestate=mm_bosstransition;
						}
						else
							jumpingtimer=0;
						falling=true;
					}
					else {
						//			calcfalling();
						if (falling)
							y+=2;
					}
				}
				skipmove=false;
				
				if (key[KEY_LSHIFT])
					shooting=true;
				else
					shooting=false;
				
				if (key[KEY_Z])
				{
					if (zreleased)
					{
						oldstate=gamestate;
						gamestate=mm_paused;
						statetimer=weapon;
						zreleased=false;
					}
				}
				else
				{
					if (!zreleased)
						zreleased=true;
				}
				
				if (shootwait>0) {
					shootwait--;
				}
				
				if (shooting&&(shootwait==0)) {
					addbullet(new Bullet(x+tilesize-6,y,weapon));
					shootwait=5;
				}
			}
			
		};
		void draw() {
			if (damaged==0)
				masked_blit(playertiles[2*falling+shooting],buffer,0,0,x,playerscreencoord(),size.x,size.y);
			else {
				if (damaged%3==0)
					masked_blit(playertiles[2*falling+shooting],buffer,0,0,x,playerscreencoord(),size.x,size.y);
				damaged--;
			}
		};
	};

Player *player;


class Spikey: public Entity
	{
	public:
		int theta;
		int x_cent;
		int y_cent;
		Spikey(int p_y, int p_theta=0)
		{
			y_cent=p_y;
			x_cent=tilesize*4;
			size.x=tilesize;
			size.y=tilesize;
			theta=p_theta;
			damage=20;
			 material=true;
			 hittype=h_deflect;
			 canhurt=true;
			/*	
			material=false;
			hittype=h_no;
			canhurt=false;
			 */
		}
		void move()
		{
			theta=(theta+5)%360;
			x=x_cent+Cos[theta];
			y=y_cent+Sin[theta];
			if ((x>tilesize*3)&&(x<tilesize*5))
			{
				material=true;
				canhurt=true;				
			}
			else
			{			
				material=false;
				canhurt=false;
			}
			if ((x>tilesize*4-tilesize/3)&&(x<tilesize*5))
				hittype=h_deflect;
			else
				hittype=h_no;
				
		}
		void draw()
		{
			masked_blit(leveltiles[12][9],buffer,0,0,x,screencoord(y),size.x,size.y);				
		}
	};


class Spinner: public Entity
	{
	public:
		int health;
		Entity *e1;
		Entity *e2;
		int damaged;
	Spinner(int p_y)
		{
			y=p_y;
			x=tilesize*4;
			size.x=tilesize;
			size.y=tilesize;
			e1=new Spikey(p_y,0);
			e2=new Spikey(p_y,180);
			addenemy(e1);
			addenemy(e2);
			health=5;
			material=true;
			canhurt=true;
			hittype=h_yes;
			damaged=0;
		}
		void hit(int d) 
		{
			damaged=5;
			health-=d;
			if (health<=0) 
			{
				playsample(s_explode);
				deleteentity(e1);
				deleteentity(e2);
				deleteentity(this);
			}
		}	
		void move()
		{
			if (damaged>0)
				damaged--;	
		}
		void draw()
		{			
			if (damaged%2==0) 
				masked_blit(leveltiles[12][8],buffer,0,0,x,screencoord(y),size.x,size.y);				
		}
	};


class Bossbullet: public Entity
	{
	public:
		int speed;
		int lifespan;
		BITMAP *img;
		Bossbullet(int xoffset, int yoffset, int yspeed, int xwidth, int xheight, bool deflect, int b_damage, BITMAP *image)
		{
			canhurt=true;
			x=tilesize*4+xoffset;
			y=tilesize+yoffset;
			size.x=xwidth;
			size.y=xheight;
			img=image;
			lifespan=30;
			speed=yspeed;
			if (deflect)
				hittype=h_deflect;
			else
				hittype=h_no;
			damage=b_damage;
		}
		
		void notifyhurt()
		{
			deleteentity(this);
		}
		void move()
		{
			y+=speed;
			lifespan--;
			if (lifespan==0)
			{
				deleteentity(this);
			}
		}
		
		
		void draw()
		{
			masked_blit(img,buffer,0,0,x,screencoord(y),size.x,size.y);	
		}
	};



const int animlength[levelcount]={4,14,16,6,7};
const int maxanimlength=16;

const int bossanim[levelcount][maxanimlength]={
{0,1,0,2,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,1,2,5,5,6,0,3,4,5,5,6,0,0},
{0,1,0,1,0,1,2,1,2,3,4,5,6,6,2,1},
{0,2,3,1,2,3,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0}};

const int bossact[levelcount][maxanimlength]= {
{0,1,0,2,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,1,0,0,0,0,0,2,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0},
{0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}};

const int bulletsize[levelcount][2]={{5,6},{5,16},{tilesize,tilesize},{tilesize,tilesize},{5,6}};
const int bulletoffset[levelcount][3][2]={	
{ {1,9}, {10,5}, {1,5}},
{ {0,5}, {10,5}, {1,5}},
{ {1,5}, {1,5}, {1,5}},
{ {0,-5}, {1,5}, {1,5}},
{ {1,5}, {1,5}, {1,5}}};
const int bulletspeed[levelcount][3]={
{4	,4	,4	},
{4	,4	,4	},
{3	,4	,4	},
{4	,4	,4	}};

const int bulletdamage[levelcount]={5,5,17,5,5};		
const int animspeed=20;

class Boss: public Entity
	{
	public:
		int timer;
		int health;
		Boss() {
			x=tilesize*4;
			y=tilesize;
			size.x=tilesize;
			size.y=tilesize;
			timer=0;
			hittype=h_yes;
			canhurt=true;
			damaged=0;
			health=maxhealth*2;
		}
		void hit(int d)
		{
			damaged=5;
			if (health>d)
				health-=d;
			else 
			{
				health=0;
				bossdead=true;
				playsample(s_teleport_out);
				endtimer=endpause;
			}
		}
		void move()
		{
			timer=(timer+1)%(animlength[level]*animspeed);
			if (timer%(animspeed)==0)
			{
				int b=timer/animspeed;
				if (bossact[level][b]>0)
					addenemy(new Bossbullet(
											bulletoffset[level][bossact[level][b]-1][0],
											bulletoffset[level][bossact[level][b]-1][1],
											bulletspeed[level][bossact[level][b]-1],
											bulletsize[level][0],
											bulletsize[level][1],
											false,
											bulletdamage[level],
											leveltiles[9+level][6+bossact[level][b]]
											));	
			}
			if (damaged>0) damaged--;
		}
		void draw() {
			if (damaged%2==0)
				masked_blit(leveltiles[9+level][bossanim[level][timer/animspeed]],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
	};

Boss *boss;

class Bossbarrier: public Platform
	{
	public:
		Bossbarrier():Platform(8*tilesize, 0,0,0) {
			canhurt=false;
			material=true;
			x=tilesize*4;
		}
		void draw() {
			if ((gamestate==mm_level)||(gamestate==mm_boss))
				masked_blit(leveltiles[7][0],buffer,0,0,x,screencoord(y),size.x,size.y);
			else if (gamestate==mm_bosstransition) {
				//to open it up (also includes sound code)
				
				if (statetimer<20) {
					masked_blit(leveltiles[7][0],buffer,0,0,x,screencoord(y),max(size.x-(statetimer/2)*2,0),size.y);
					if (statetimer%2==0) {
						playsample(s_barriertick);
					}
				}
				if (statetimer>=20+2*tilesize) {
					masked_blit(leveltiles[7][0],buffer,0,0,x,screencoord(y),min((statetimer/2)*2-20-2*tilesize,size.x),size.y);
					if (statetimer%2==0) {
						playsample(s_barriertick);
					}
				}
				//will have to include more complicated code to close it after
			}
		}
		void move() {
			
			if (gamestate==mm_level) {
				if (player->y==y+tilesize) {
					gamestate=mm_bosstransition;
					deleteforboss();
					statetimer=0;
					player->falling=true;
				}
			}
			else if (gamestate==mm_bosstransition) {
				statetimer++;
				if ((statetimer>=20)&&(statetimer<20+2*tilesize))
					player->y--;
				else if (statetimer==20+3*tilesize)
				{
					gamestate=mm_boss;	
					boss =new Boss();			
					addenemy( boss );
				}
				// if statetimer==blah then go to boss mode
			}
			
		}
	};

class Smashcrate: public Platform
	{
	public:
		int health;
		bool regenerating;
		int damaged;
		Smashcrate(int p_y):Platform(p_y, 0,0,0) {
			material=true;
			x=tilesize*4;
			regenerating=false;
			health=100;
			damaged=0;
			hittype=h_yes;
		}
		void hit(int d) {
			health-=d*30;
			damaged=5;
			if (health<=0) {
				health=0;
				regenerating=true;
				hittype=h_no;
				material=false;
			}
		}
		void move() {
			if (regenerating) {
				health++;
				if (health>=100) {
					regenerating=false;
					hittype=h_yes;
					material=true;
				}
			}
			if (damaged>0) damaged--;
			
		}
		void draw() {
			if (damaged%2==0)
				masked_blit(leveltiles[8][2*regenerating+(health>50)],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
	};







class Ricketyplatform: public Platform
	{
	public:
		int damaged;
		int health;
		Ricketyplatform(int p_y):Platform(p_y, 0,0,0) {
			material=true;
			x=tilesize*4;
			damaged=0;
			hittype=h_yes;
			passthrough=true;
			hittype=h_yes;
			material=true;
			health=3;
//			size.y=3;
		}
		void hit(int d) {
				if (health-d>0)
				{
					health-=d;
				}
				else if (screencoord(y)>0)
				{
					hittype=h_no;
					addenemy(new Ricketyfalling(y+4));	
				}
		}
		void move() {}
		void draw() {
			if (damaged%2==0)
				masked_blit(leveltiles[9+(hittype==h_no)][9],buffer,0,0,x,screencoord(y),size.x,tilesize);
		}
	};



class Conveyor: public Platform
	{
	public:
		int top;
		int bottom;
		Conveyor(int p_bottom, int p_top, int p_time, int init_time=0):Platform(p_bottom, 0,0,0) {
			x=tilesize*4;
			hittype=h_yes;
			timer=init_time;
			loopsize=p_time;
			material=(timer<(loopsize/2));
			bottom=p_bottom;
			top=p_top;
		}
		
		void move() {
			timer=(timer+1)%loopsize;
			y=bottom;//(bottom*(loopsize-1-timer)) +(top*(timer+1))/loopsize;
			if (timer<(loopsize/2))
			{
				material=true;
				y=bottom+(top-bottom)*timer*2/loopsize;
			}
			else
			{
				material=false;
				y=top-(top-bottom)*(timer-loopsize/2)*2/loopsize;
			}
		}
		void draw() {
		//	if (y==bottom)
		//		masked_blit(leveltiles[6][7],buffer,0,0,x,screencoord(y),size.x,size.y);				
		//	else
				masked_blit(leveltiles[4+!material][9],buffer,0,0,x,screencoord(y),size.x,size.y);
		}
	};

class Helmetdude: public Entity
	{												  //16 frames wide
	public:
		//loopside 250
		//175 down, rest up
		int timer;
		int health;
		int damaged;
		void move() {
			timer=(timer+1)%175;
			if (damaged>0)
				damaged--;
			
			if (timer==130) {
				hittype=h_yes;
			}
			else if ((timer==140)&&(abs(x-(entities[0]->x))<100))
			{
				addenemy(new Enemybullet(x+tilesize/2+6/2,y,-1));
				addenemy(new Enemybullet(x+tilesize/2+6/2,y+tilesize-7,+1));
			}
			else if (timer==0) {
				hittype=h_deflect;
			}
		}
		void draw() {
			if (damaged%2==0) {
				if (timer>130) {
					masked_blit(leveltiles[5][1],buffer,0,0,x,screencoord(y),size.x,size.y);
				}
				else {
					masked_blit(leveltiles[5][0],buffer,0,0,x,screencoord(y),size.x,size.y);
				}
			}
		}
		void hit(int d) {
			damaged=5;
			health-=d;
			if (health<=0) {
				playsample(s_explode);
				deleteentity(this);
			}
		}
		Helmetdude(int p_y) {
			x=tilesize*4;
			y=p_y;
			size.x=tilesize;
			size.y=tilesize;
			health=2;
			timer=0;
			material=true;
			canhurt=true;
			damaged=0;
			hittype=h_deflect;
		}
	};

const int b_wait=50;
const int b_fly=25;

class Bird: public Entity
	{												  //16 frames wide
	public:
		//loopside 50 50 50 50 say
		int inity;
		int timer;
		int health;
		int damaged;
		void move() {
			if (damaged>0)
				damaged--;
			
			timer=(timer+1)%(2*(b_wait+b_fly));
			if (timer<b_wait)
			{
				x=tilesize*3;	
				y=inity;
				material=false;
				hittype=h_no;
				canhurt=false;
				
			}
			else if (timer<b_wait+b_fly)
			{
				//the four is the bitmap offset
				x=tilesize*3+8+((timer-b_wait)*(2*tilesize-8))/b_fly;
				y=inity+7;
				material=true;
				canhurt=true;
				canhurt=true;
				if (x>(tilesize*4+tilesize/4))
				{
					hittype=h_yes;
				}
				else
				{	
					hittype=h_no;
				}
			}
			else if (timer<2*b_wait+b_fly)
			{
				x=tilesize*5;
				y=inity;
				material=false;
				hittype=h_no;
				canhurt=false;			
			}
			else
			{
				x=tilesize*5-1-((timer-2*b_wait-b_fly)*(2*tilesize-8))/b_fly;
				y=inity+7;				
				material=true;
				canhurt=true;
				canhurt=true;
				if (x>(tilesize*4+tilesize/4))
				{
					hittype=h_yes;
				}
				else
				{	
					hittype=h_no;
				}
			}
		}
		void draw() {
			if (damaged%2==0) {
				if (timer<b_wait) 
					masked_blit(leveltiles[8][4+((timer/5)%2==0)],buffer,0,0,x,screencoord(y),tilesize,tilesize);						
				else if (timer<(b_wait+b_fly))
					masked_blit(leveltiles[8][6],buffer,4,7,x,screencoord(y),9,5);				
				else if (timer<(2*b_wait+b_fly))
					masked_blit(leveltiles[8][7+((timer/5)%2==0)],buffer,0,0,x,screencoord(y),tilesize,tilesize);						
				else 
					masked_blit(leveltiles[8][9],buffer,3,7,x,screencoord(y),9,5);				
			}
		}
					
	
		void hit(int d) {
			damaged=5;
			health-=d;
			if (health<=0) {
				playsample(s_explode);
				deleteentity(this);
			}
		}
     		
		Bird(int p_y, bool rightstart) {
			x=tilesize*3;
			inity=p_y;
			y=p_y;
			size.x=tilesize;
			size.y=5;
			health=2;
			timer=(b_fly+b_wait)*rightstart-1;
			move();
			material=false;
			hittype=h_no;
			canhurt=false;
			damaged=0;
		}
	};


class Spike: public Entity
	{												  //16 frames wide
	public:
		int timer;
		int on;
		int off;
		int loopsize;
		void move() {
			timer=(timer+1)%loopsize;
			if ((timer>=on+3)&&(timer<off-3)) {
				material=true;
				hittype=h_deflect;
				canhurt=true;
			}
			else {
				material=false;
				hittype=h_no;
				canhurt=false;
			}
		}
		void draw() {
			if (material) {
				int width=min(off-timer,min(timer-on,size.x));
				//do the telescoping wassit here using max/min/whatever retract in and out
				masked_blit(leveltiles[6][0],buffer,0,0,x+tilesize-width,screencoord(y),width,size.y);
			}
		}
		Spike(int p_y, int p_on, int p_off, int p_loopsize) {
			hittype=h_deflect;
			x=tilesize*4;
			y=p_y;
			size.x=tilesize;
			size.y=tilesize;
			on=p_on;
			damage=20;
			off=p_off;
			loopsize=p_loopsize;
			material=true;
			damage=100;
			timer=0;
		}
		
	};
